## ngs-sdk 1.2.3

=== Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

# default response to "make"
default: subdirs

# the sub-directories
SUBDIRS =    \
	ngs-sdk \
	ngs-java \
	ngs-python \
	ngs-bam

SUBDIRS_CLN = \
	$(addsuffix _cln,$(SUBDIRS))

SUBDIRS_INST = \
	$(addsuffix _inst,$(SUBDIRS))

SUBDIRS_TST = \
	$(addsuffix _test,$(SUBDIRS))

subdirs: $(SUBDIRS)

clean: $(SUBDIRS_CLN)

test: $(SUBDIRS_TST)

install: $(SUBDIRS_INST)

$(SUBDIRS):
	@ $(MAKE) -C $@

$(SUBDIRS_CLN):
	@ $(MAKE) -C $(subst _cln,,$@) clean

$(SUBDIRS_INST):
	@ $(MAKE) -s --no-print-directory -C $(subst _inst,,$@) install

$(SUBDIRS_TST):
	@ $(MAKE) -C $(subst _test,,$@) test

.PHONY: $(SUBDIRS) $(SUBDIRS_CLN) $(SUBDIRS_INST)

=== ngs-bam/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

# default response to "make"
default: std

# the sub-targets
SUBDIRS =    \

SUBTARGS =     \

include $(CURDIR)/Makefile.rules

std: Makefile.config
	@ $(MAKE) -f Makefile.libs std

clean: Makefile.config
	@ $(MAKE) -f Makefile.libs clean

install: Makefile.config
	@ $(MAKE) -f Makefile.libs
	@ perl $(TOP)/setup/install

.PHONY: std clean install

=== ngs-sdk/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

# default response to "make"
default: subtargs

# the sub-targets
SUBDIRS =    \
	language \
	dispatch \
	adapter  \

SUBTARGS =     \
	$(SUBDIRS) \
	sdk-libs   \

include $(CURDIR)/Makefile.rules

sdk-libs: Makefile.config
	@ $(MAKE) -f Makefile.libs

sdk-libs_cln: Makefile.config
	@ $(MAKE) -f Makefile.libs clean

sdk-libs_inst: Makefile.config 
	@ echo "Checking make status of object libraries..."
	@ $(MAKE) -s --no-print-directory sdk-libs
	@ $(MAKE) -s --no-print-directory -f Makefile.install install

=== ngs-java/examples/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TARGETS =             \
	NGS-JavaTest.jar

std: $(TARGETS)

clean:
	rm -f $(TARGETS) examples/*.class

.PHONY: default std $(TARGETS)

NGS_EXAMPLES = \
	PileupTest \
	AlignTest \
	AlignSliceTest \
	FragTest \
	RefTest \
	ReadGroupTest \

NGS_EXAMPLES_PATH = \
	$(addprefix examples/,$(addsuffix .java,$(NGS_EXAMPLES)))

NGS-JavaTest.jar: $(NGS_EXAMPLES_PATH)
	javac $^ -d . 
	( jar cf $@ `find examples -name "*.class"`; chmod -x,o-w $@ ) || ( rm -f $@ && false )

# ===========================================================================
#
# example runs

JAVAFLAGS = -classpath $(CLASSPATH):.

# Expect libngs-sdk.so and libncbi-vdb.so somewhere inside $LD_LIBRARY_PATH;
#   if the libraries are not found, error out.
# Comment out to rely on "smart load" instead (may download libraries from NCBI):
JAVAFLAGS += -Djava.library.path=$(LD_LIBRARY_PATH) -Dvdb.System.loadLibrary=1

# uncomment to see detailed log"
#JAVAFLAGS += -Dvdb.log=FINEST

run_frag: NGS-JavaTest.jar
	java $(JAVAFLAGS) examples.FragTest ERR225922 10000 2  $(REDIRECT)

run_align: NGS-JavaTest.jar
	java $(JAVAFLAGS) examples.AlignTest ERR225922 10000 2 $(REDIRECT)

run_align_slice: NGS-JavaTest.jar
	java $(JAVAFLAGS) examples.AlignSliceTest SRR1121656 1 1 9999 $(REDIRECT)

run_pileup: NGS-JavaTest.jar
	java $(JAVAFLAGS) examples.PileupTest SRR1121656 1 9999 10003 $(REDIRECT)

run_ref: NGS-JavaTest.jar
	java $(JAVAFLAGS) examples.RefTest SRR1121656 $(REDIRECT)
    
run_read_group: NGS-JavaTest.jar
	java $(JAVAFLAGS) examples.ReadGroupTest SRR1121656 $(REDIRECT)
    
ALL_TESTS = run_frag run_align run_align_slice run_pileup run_ref run_read_group

run_all: $(ALL_TESTS)

.PHONY: $(ALL_TESTS)

# ===========================================================================
#
# expected results for auto-testing
#
expected.txt update_expected: 
	rm -f expected.txt; $(MAKE) run_all REDIRECT=">>expected.txt"

run_and_diff: expected.txt  
	rm -f actual.txt; $(MAKE) run_all REDIRECT=">>actual.txt"
	diff expected.txt actual.txt && rm actual.txt && echo NGS Java examples work as expected

.PHONY: update_expected run_and_diff

=== ngs-sdk/adapter/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ..)
include $(TOP)/Makefile.config

INTLIBS = \

EXTLIBS = \
	ngs-adapt-c++

TARGETS =      \
	$(INTLIBS) \
	$(EXTLIBS)

all std: $(TARGETS)

clean:
	rm -rf $(LIBDIR)/$(LPFX)ngs-adapt* $(OBJDIR)

.PHONY: default all std $(TARGETS)

ngs-adapt-c++: \
	$(LIBDIR) $(OBJDIR) $(LIBDIR)/$(LPFX)ngs-adapt-c++-static.$(LIBX)

ADAPT_SRC =              \
	ReadCollectionItf    \
	PileupItf            \
	PileupEventItf       \
	ReferenceItf         \
	ReferenceSequenceItf \
	AlignmentItf         \
	ReadGroupItf         \
	ReadItf              \
	FragmentItf          \
	StatisticsItf        \
	StringItf            \
	Refcount             \
	ErrorMsg             \
	ErrBlock

ADAPT_OBJ = \
	$(addprefix $(OBJDIR)/,$(addsuffix .$(LOBX),$(ADAPT_SRC)))

$(LIBDIR)/$(LPFX)ngs-adapt-c++.$(VERSION_LIBX): $(ADAPT_OBJ)
	$(AR) $@ $^

$(LIBDIR)/$(LPFX)ngs-adapt-c++.$(MAJVERS_LIBX): $(LIBDIR)/$(LPFX)ngs-adapt-c++.$(VERSION_LIBX)
	rm -f $@
	ln -s $(notdir $^) $@

$(LIBDIR)/$(LPFX)ngs-adapt-c++.$(LIBX): $(LIBDIR)/$(LPFX)ngs-adapt-c++.$(MAJVERS_LIBX)
	rm -f $@
	ln -s $(notdir $^) $@  

$(LIBDIR)/$(LPFX)ngs-adapt-c++-static.$(LIBX): $(LIBDIR)/$(LPFX)ngs-adapt-c++.$(LIBX)
	rm -f $@
	ln -s $(notdir $^) $@

=== ngs-sdk/dispatch/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ..)
include $(TOP)/Makefile.config

INTLIBS = \
	ngs-disp

EXTLIBS =   \

TARGETS =      \
	$(INTLIBS) \
	$(EXTLIBS)

all std: $(TARGETS)

clean:
	rm -rf $(ILIBDIR)/$(LPFX)ngs-disp* $(OBJDIR)

.PHONY: default all std $(TARGETS)

ngs-disp: $(ILIBDIR) $(OBJDIR) $(ILIBDIR)/$(LPFX)ngs-disp.$(LIBX)

# core dispatcher sources
DISP_SRC =                   \
	ReadCollectionItf    \
	ReferenceItf         \
	ReferenceSequenceItf \
	PileupItf            \
	PileupEventItf       \
	AlignmentItf         \
	ReadGroupItf         \
	ReadItf              \
	FragmentItf          \
	StatisticsItf        \
	PackageItf           \
	StringItf            \
	Refcount             \
	VTable               \
	ErrBlock             \
	ErrorMsg

# core dispatcher object files
DISP_OBJ = \
	$(addprefix $(OBJDIR)/,$(addsuffix .$(LOBX),$(DISP_SRC)))

# rule to produce the static dispatch library
$(ILIBDIR)/$(LPFX)ngs-disp.$(LIBX): $(DISP_OBJ)
	$(AR) $@ $^

=== ngs-sdk/examples/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: std

ifeq (Darwin,$(shell uname -s))
MFLAGS += -mmacosx-version-min=10.6
endif

CC = cc $(MFLAGS) $(CFLAGS)
CXX = c++ $(MFLAGS) $(CPPFLAGS)

# ensure definition of paths, namely
# NCBI_VDB_LIBDIR and NGS_LIBDIR
include $(CURDIR)/Makefile.config

TARGETS =           \
    FragTest        \
    AlignTest       \
    AlignSliceTest  \
    RefTest         \
    PileupTest      \
    FastqTableDump 

# This rule triggers detection of the libraries and headers
# in addition to building the examples
std: $(TARGETS)

$(TARGETS): $(NCBI_VDB_LIBDIR)/libncbi-vdb-static.a ncbi-headers $(NGS_LIBDIR)/libngs-c++.a ngs-headers

clean:
	rm -f $(TARGETS) *.o
	rm -rf *.dSYM

.PHONY: default std $(TARGETS)

# C++ applications require two NGS libraries:
#  1. ngs-c++ which contains the NGS "front-end" interfaces
#  2. an NGS "back-end" engine such as ncbi-ngs-c++
#     which in turn relies upon ncbi-vdb to access the SRA
#
TEST_LIBS =              \
    -L$(NCBI_VDB_LIBDIR) \
    -L$(NGS_LIBDIR)      \
    -lncbi-ngs-c++       \
    -lngs-c++            \
	-lngs-bam-c++        \
    -lncbi-ngs-c++       \
    -lncbi-vdb-static    \
    -lngs-adapt-c++      \
    -lpthread            \
    -ldl                 \
    -lm

# FragTest
#  access read fragments
FRAG_TEST_SRC = \
    FragTest.cpp

FragTest: $(FRAG_TEST_SRC)
	$(CXX) -g -o $@ $(FRAG_TEST_SRC) $(TEST_LIBS)

# RefTest ###################
REF_TEST_SRC = \
    RefTest.cpp

RefTest: $(REF_TEST_SRC)
	$(CXX) -g -o $@ $(REF_TEST_SRC) $(TEST_LIBS)

# AlignTest #################
#  access alignments
ALIGN_TEST_SRC = \
    AlignTest.cpp

AlignTest: $(ALIGN_TEST_SRC)
	$(CXX) -g -o $@ $(ALIGN_TEST_SRC) $(TEST_LIBS)

# AlignSliceTest
#  slice a ReadCollection and output alignments
ALIGNSLICE_TEST_SRC = \
    AlignSliceTest.cpp

AlignSliceTest: $(ALIGNSLICE_TEST_SRC)
	$(CXX) -g -o $@ $(ALIGNSLICE_TEST_SRC) $(TEST_LIBS)


# PileupTest
#  slice a ReadCollection and produce pileups
PILEUP_TEST_OBJ = \
    PileupTest.cpp

PileupTest: $(PILEUP_TEST_OBJ)
	$(CXX) -g -o $@ $(PILEUP_TEST_OBJ) $(TEST_LIBS)

# FastqTableDump
#  produce fastq-like table
FASTQ_TABLE_DUMP_OBJ = \
    FastqTableDump.cpp

FastqTableDump: $(FASTQ_TABLE_DUMP_OBJ)
	$(CXX) -g -o $@ $(FASTQ_TABLE_DUMP_OBJ) $(TEST_LIBS)

# ===========================================================================
#
# installation
#
install: 
	@ cp *.cpp Makefile Makefile.config $(INST_TARGET)

# ===========================================================================
#
# example runs

run_frag:  FragTest
	./$^ ERR225922 10000 2 $(REDIRECT)

run_align: AlignTest
	./$^ ERR225922 10000 2 $(REDIRECT)

run_align_slice: AlignSliceTest
	./$^ SRR1121656 1 1 9999 $(REDIRECT)

run_pileup: PileupTest
	./$^ SRR1121656 1 9999 10003 $(REDIRECT)

run_ref: RefTest
	./$^ SRR1121656 $(REDIRECT)

ALL_TESTS = run_frag run_align run_align_slice run_pileup run_ref

run_all: $(ALL_TESTS)

.PHONY: $(ALL_TESTS)

# ===========================================================================
#
# expected results for auto-testing
#
expected.txt update_expected: 
	rm -f expected.txt
	$(MAKE) run_all REDIRECT=">>expected.txt"

run_and_diff: expected.txt
	rm -f actual.txt
	$(MAKE) run_all REDIRECT=">>actual.txt"
	@ diff expected.txt actual.txt && rm actual.txt && echo "NGS C++ examples work as expected"

.PHONY: update_expected run_and_diff install

=== ngs-sdk/language/python/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: std

TOP ?= $(abspath ../..)
include $(TOP)/Makefile.config

INT_LIBS = \
	ngs-bind-python

EXT_LIBS = \

TARGETS =       \
	$(INT_LIBS) \
	$(EXT_LIBS)

all std: $(TARGETS)

clean:
	rm -rf $(ILIBDIR)/$(LPFX)ngs-bind-python* $(OBJDIR)

.PHONY: default all std $(TARGETS)

#-------------------------------------------------------------------------------
# ngs-bind-python
#
ngs-bind-python: $(ILIBDIR) $(OBJDIR) $(ILIBDIR)/$(LPFX)ngs-bind-python.$(LIBX)

BIND_SRC =                  \
	AlignmentItf            \
	AlignmentIteratorItf    \
	ErrorMsg                \
	FragmentItf             \
	FragmentIteratorItf     \
	PackageItf				\
	PileupEventItf          \
	PileupEventIteratorItf  \
	PileupItf               \
	PileupIteratorItf       \
	ReadCollectionItf       \
	ReadGroupItf            \
	ReadGroupIteratorItf    \
	ReadItf                 \
	ReadIteratorItf         \
	ReferenceItf            \
	ReferenceIteratorItf    \
	ReferenceSequenceItf	\
	StatisticsItf           \
	Refcount                \
	StringItf


BIND_OBJ = \
	$(addprefix $(OBJDIR)/,$(addsuffix .$(LOBX),$(addprefix py_,$(BIND_SRC))))

$(ILIBDIR)/$(LPFX)ngs-bind-python.$(LIBX): $(BIND_OBJ)
	$(AR) $@ $^

=== debian/changelog ===
ngs-sdk (1.2.3-2) unstable; urgency=medium

  * debian/rules: create dynamic library in expected directory
    Closes: #813557
  * Turn architecture checking for non-Intel architectures from error into
    warning that does not cause a failure
    Closes: #813559

 -- Andreas Tille <tille@debian.org>  Sat, 06 Feb 2016 10:35:42 +0100

ngs-sdk (1.2.3-1) unstable; urgency=medium

  * Initial release (Closes: #809375)

 -- Olivier Sallou <osallou@debian.org>  Mon, 01 Feb 2016 22:26:21 +0100

=== debian/control ===
Source: ngs-sdk
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Olivier Sallou <osallou@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               d-shlibs,
               python-markdown,
               python-all-dev,
               python3-all-dev,
               dh-python,
               javahelper,
               openjdk-8-jdk
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/ngs-sdk.git
Vcs-Git: git://anonscm.debian.org/debian-med/ngs-sdk.git
Homepage: https://github.com/ncbi/ngs

Package: libngs-sdk1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Next Generation Sequencing language Bindings
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.

Package: libngs-sdk-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libngs-sdk1 (= ${binary:Version})
Description: Next Generation Sequencing language Bindings (development)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 This is the development package.

Package: libngs-java
Architecture: any
Section: java
Depends: ${misc:Depends},
         ${java:Depends},
         libngs-sdk-dev (= ${binary:Version})
Recommends: ${java:Recommends}
Description: Next Generation Sequencing language Bindings (Java bindings)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 Java bindings.


Package: python-ngs
Architecture: any
Section: python
Depends: ${python:Depends},
         ${misc:Depends},
         libngs-sdk-dev (= ${binary:Version})
Description: Next Generation Sequencing language Bindings (Python bindings)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 Python bindings.

Package: python3-ngs
Architecture: any
Section: python
Depends: ${python3:Depends},
         ${misc:Depends},
         libngs-sdk-dev (= ${binary:Version})
Description: Next Generation Sequencing language Bindings (Python3 bindings)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 Python3 bindings.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

DEBPKGNAME     := $(shell dpkg-parsechangelog | awk '/^Source:/ {print $$2}')

OS := $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
CPU := $(shell dpkg-architecture -qDEB_BUILD_GNU_CPU)
BUILDTYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
SODIR := $(DEBPKGNAME)/$(BUILDTYPE)/$(DEBPKGNAME)/$(OS)/gcc/$(CPU)

build2vers := $(shell pyversions -sv)
build3vers := $(shell py3versions -sv)

%:
	dh $@ --with python2,python3,javahelper

override_dh_auto_clean:
	if [ -e ngs-sdk/Makefile.config.$(OS).$(CPU)] ; then \
	#    dh_auto_clean --sourcedirectory=$(DEBPKGNAME) ; \
	dh_auto_clean ; \
	fi
	rm -rf ngs-java/$(BUILDTYPE)
	rm -rf ngs-bam/$(BUILDTYPE)
	rm -f ngs-bam/Makefile.config
	rm -f ngs-bam/Makefile.config.install.linux.x86_64.prl
	rm -f ngs-bam/Makefile.config.linux.x86_64
	rm -f ngs-bam/reconfigure

	rm -rf $(DEBPKGNAME)/$(BUILDTYPE)
	rm -rf ngs-python/build

override_dh_auto_configure:
	# # that's no standard configure script lacking support of default options \
	./configure --build=$(BUILDTYPE) --prefix=/usr ;

override_dh_auto_build:
	#dh_auto_build --sourcedirectory=$(DEBPKGNAME)
	dh_auto_build --sourcedirectory=$(DEBPKGNAME)
	# Remove ngs-bam generation, expects ngs-sdk and cannot find a way
	# to specify it
	#cd ngs-bam && LD_LIBRARY_PATH=../$(SODIR)/rel/lib ./configure --build=$(BUILDTYPE) --prefix=/usr --with-ngs-sdk-prefix=../ngs-sdk
	#dh_auto_build --sourcedirectory=ngs-bam
	dh_auto_build --sourcedirectory=ngs-java
	markdown_py -f README.html README.md

override_dh_auto_test:
	make -C $(DEBPKGNAME)/test
	# Tests of Java binding disabled because need external lib ncbi-vdb,
	# not available in Debian at this time
	#CLASSPATH=../$(BUILDTYPE)/ngs-java/jar/ngs-java.jar LD_LIBRARY_PATH=$(SODIR)/rel/lib:$(LD_LIBRARY_PATH) make -C ngs-java/examples
	#CLASSPATH=../$(BUILDTYPE)/ngs-java/jar/ngs-java.jar LD_LIBRARY_PATH=../../$(SODIR)/rel/lib:$(LD_LIBRARY_PATH) make -C ngs-java/examples run_all

override_dh_auto_install:
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-a \
		    --exclude-la \
		    --movedev "$(SODIR)/rel/lib/*.a*" usr/lib/$(BUILDTYPE) \
		    --movedev "$(SODIR)/rel/ilib/*.a" usr/lib/$(BUILDTYPE) \
		    $(SODIR)/rel/lib/libngs-sdk.so

override_dh_install:
	dh_install -ppython3-ngs
	set -e && for i in $(build3vers); do \
		cd ngs-python ; \
		python$$i ./setup.py install --install-layout=deb --root ../debian/python3-ngs; \
		cd .. ; \
	done
	dh_install -ppython-ngs
	set -e && for i in $(build2vers); do \
		cd ngs-python ; \
		python$$i ./setup.py install --install-layout=deb --root ../debian/python-ngs; \
		cd .. ; \
	done
	find debian -name "*.pyc" -delete
	find debian -type d -name __pycache__ | xargs rm -rf

=== debian/watch ===
version=3

https://github.com/ncbi/ngs/releases .*/archive/(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## ngs-sdk 1.2.5

=== ngs-java/examples/Makefile ===
--- 
+++ 
@@ -25,6 +25,8 @@
 
 default: std
 
+#DEBUGGING = -d
+
 TARGETS =             \
 	NGS-JavaTest.jar
 
@@ -36,18 +38,19 @@
 .PHONY: default std $(TARGETS)
 
 NGS_EXAMPLES = \
+	AlignSliceTest \
+	AlignTest \
+	DumpReferenceFASTA \
+	FragTest \
 	PileupTest \
-	AlignTest \
-	AlignSliceTest \
-	FragTest \
+	ReadGroupTest \
 	RefTest \
-	ReadGroupTest \
 
 NGS_EXAMPLES_PATH = \
 	$(addprefix examples/,$(addsuffix .java,$(NGS_EXAMPLES)))
 
 NGS-JavaTest.jar: $(NGS_EXAMPLES_PATH)
-	javac $^ -d . 
+	javac $(DEBUGGING) $^ -d . 
 	( jar cf $@ `find examples -name "*.class"`; chmod -x,o-w $@ ) || ( rm -f $@ && false )
 
 # ===========================================================================
@@ -70,6 +73,9 @@
 run_align: NGS-JavaTest.jar
 	java $(JAVAFLAGS) examples.AlignTest ERR225922 10000 2 $(REDIRECT)
 
+run_dump: NGS-JavaTest.jar
+	java $(JAVAFLAGS) examples.DumpReferenceFASTA SRR520124 1 $(REDIRECT)
+
 run_align_slice: NGS-JavaTest.jar
 	java $(JAVAFLAGS) examples.AlignSliceTest SRR1121656 1 1 9999 $(REDIRECT)
 
@@ -82,7 +88,8 @@
 run_read_group: NGS-JavaTest.jar
 	java $(JAVAFLAGS) examples.ReadGroupTest SRR1121656 $(REDIRECT)
     
-ALL_TESTS = run_frag run_align run_align_slice run_pileup run_ref run_read_group
+ALL_TESTS = run_frag run_align run_align_slice \
+	run_pileup run_ref run_read_group run_dump
 
 run_all: $(ALL_TESTS)

=== debian/changelog ===
ngs-sdk (1.2.5-1) unstable; urgency=medium

  * New upstream release 

 -- Olivier Sallou <osallou@debian.org>  Thu, 18 Aug 2016 10:51:22 +0200

ngs-sdk (1.2.4-2) unstable; urgency=medium

  * Add a maven2 pom file for libjava-ngs

 -- Vincent Danjean <vdanjean@debian.org>  Wed, 06 Jul 2016 21:57:29 +0200

ngs-sdk (1.2.4-1) unstable; urgency=medium

  * New upstream version
  * Add missing header files to devel package

 -- Andreas Tille <tille@debian.org>  Mon, 06 Jun 2016 12:54:51 +0200

ngs-sdk (1.2.3-3) unstable; urgency=medium

  [ Andreas Tille ]
  * Really get the build working even if build results are moved to the
    wrong dir by the build system
  * cme fix dpkg-control
  * DEP5

  [ Steffen Moeller ]
  * Depend on default-jdk, not openjdk-8-java, introduce flags to javac
    to avoid Java8 bytecode, eliminating a lintian warning.
  * Bumped policy to 3.9.7, no changes required.

 -- Andreas Tille <tille@debian.org>  Sun, 10 Apr 2016 08:21:45 +0200

=== debian/rules ===
--- 
+++ 
@@ -7,16 +7,17 @@
 OS := $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
 CPU := $(shell dpkg-architecture -qDEB_BUILD_GNU_CPU)
 BUILDTYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
-SODIR := $(DEBPKGNAME)/$(BUILDTYPE)/$(DEBPKGNAME)/$(OS)/gcc/$(CPU)
+# since build-results are not ending up in the proper dir its saver to use "*" instead of "$(CPU)"
+SODIR := $(DEBPKGNAME)/$(BUILDTYPE)/$(DEBPKGNAME)/$(OS)/gcc/*
 
 build2vers := $(shell pyversions -sv)
 build3vers := $(shell py3versions -sv)
 
 %:
-	dh $@ --with python2,python3,javahelper
+	dh $@ --with python2,python3,javahelper,jh_maven_repo_helper
 
 override_dh_auto_clean:
-	if [ -e ngs-sdk/Makefile.config.$(OS).$(CPU)] ; then \
+	if [ -e ngs-sdk/Makefile.config.$(OS).$(CPU) ] ; then \
 	#    dh_auto_clean --sourcedirectory=$(DEBPKGNAME) ; \
 	dh_auto_clean ; \
 	fi
@@ -32,16 +33,17 @@
 
 override_dh_auto_configure:
 	# # that's no standard configure script lacking support of default options \
-	./configure --build=$(BUILDTYPE) --prefix=/usr ;
+	./configure --build=$(BUILDTYPE) --prefix=/usr -- --source=1.7
 
 override_dh_auto_build:
 	#dh_auto_build --sourcedirectory=$(DEBPKGNAME)
+	echo "DEBPKGNAME: $DEBPKGNAME"
 	dh_auto_build --sourcedirectory=$(DEBPKGNAME)
 	# Remove ngs-bam generation, expects ngs-sdk and cannot find a way
 	# to specify it
 	#cd ngs-bam && LD_LIBRARY_PATH=../$(SODIR)/rel/lib ./configure --build=$(BUILDTYPE) --prefix=/usr --with-ngs-sdk-prefix=../ngs-sdk
 	#dh_auto_build --sourcedirectory=ngs-bam
-	dh_auto_build --sourcedirectory=ngs-java
+	dh_auto_build --sourcedirectory=ngs-java -- JAVAC="javac -source 1.7 -target 1.7"
 	markdown_py -f README.html README.md
 
 override_dh_auto_test:
@@ -59,6 +61,7 @@
 		    --exclude-la \
 		    --movedev "$(SODIR)/rel/lib/*.a*" usr/lib/$(BUILDTYPE) \
 		    --movedev "$(SODIR)/rel/ilib/*.a" usr/lib/$(BUILDTYPE) \
+		    --movedev ngs-sdk/ngs usr/include \
 		    $(SODIR)/rel/lib/libngs-sdk.so
 
 override_dh_install:
@@ -76,3 +79,15 @@
 	done
 	find debian -name "*.pyc" -delete
 	find debian -type d -name __pycache__ | xargs rm -rf
+
+# require network, not automatically run
+# use it when the pom file must be re-downloaded from maven repo
+BASE_URL:=https://repo.maven.apache.org/maven2/gov/nih/nlm/ncbi/ngs-java
+WGET=wget --no-clobber
+get-poms:
+	$(RM) debian/ngs-java.pom debian/ngs-java.pom.asc
+	# extract upstream version
+	VERSION=$$(dpkg-parsechangelog -S Version | sed -e 's/\([+]dfsg\.\?[0-9]*\)\?-[^-]\+$$//') ; \
+	$(WGET) -O debian/ngs-java.pom $(BASE_URL)/$$VERSION/ngs-java-$$VERSION.pom && \
+	$(WGET) -O debian/ngs-java.pom.asc $(BASE_URL)/$$VERSION/ngs-java-$$VERSION.pom.asc
+	gpg --trust-model=always --status-fd 1 --no-default-keyring --keyring debian/sra-tools.gpg --verify debian/ngs-java.pom.asc
